/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package com.marcofabbian.transaction.avroschema;

import org.apache.avro.generic.GenericArray;
import org.apache.avro.specific.SpecificData;
import org.apache.avro.util.Utf8;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.SchemaStore;

@org.apache.avro.specific.AvroGenerated
public class Taxation extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = -6113106496248830761L;


  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"Taxation\",\"namespace\":\"com.marcofabbian.transaction.avroschema\",\"fields\":[{\"name\":\"id\",\"type\":\"string\",\"doc\":\"Taxation unique identifier profile\"},{\"name\":\"taxCode\",\"type\":\"string\",\"doc\":\"Unique identifier tax code\"},{\"name\":\"countryCode\",\"type\":\"string\",\"doc\":\"ISO identifier for country code\"},{\"name\":\"taxProfile\",\"type\":{\"type\":\"string\",\"java-class\":\"java.math.BigDecimal\"},\"doc\":\"Tax profile code\"}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }

  private static final SpecificData MODEL$ = new SpecificData();

  private static final BinaryMessageEncoder<Taxation> ENCODER =
      new BinaryMessageEncoder<>(MODEL$, SCHEMA$);

  private static final BinaryMessageDecoder<Taxation> DECODER =
      new BinaryMessageDecoder<>(MODEL$, SCHEMA$);

  /**
   * Return the BinaryMessageEncoder instance used by this class.
   * @return the message encoder used by this class
   */
  public static BinaryMessageEncoder<Taxation> getEncoder() {
    return ENCODER;
  }

  /**
   * Return the BinaryMessageDecoder instance used by this class.
   * @return the message decoder used by this class
   */
  public static BinaryMessageDecoder<Taxation> getDecoder() {
    return DECODER;
  }

  /**
   * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
   * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
   * @return a BinaryMessageDecoder instance for this class backed by the given SchemaStore
   */
  public static BinaryMessageDecoder<Taxation> createDecoder(SchemaStore resolver) {
    return new BinaryMessageDecoder<>(MODEL$, SCHEMA$, resolver);
  }

  /**
   * Serializes this Taxation to a ByteBuffer.
   * @return a buffer holding the serialized data for this instance
   * @throws java.io.IOException if this instance could not be serialized
   */
  public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
    return ENCODER.encode(this);
  }

  /**
   * Deserializes a Taxation from a ByteBuffer.
   * @param b a byte buffer holding serialized data for an instance of this class
   * @return a Taxation instance decoded from the given buffer
   * @throws java.io.IOException if the given bytes could not be deserialized into an instance of this class
   */
  public static Taxation fromByteBuffer(
      java.nio.ByteBuffer b) throws java.io.IOException {
    return DECODER.decode(b);
  }

  /** Taxation unique identifier profile */
  private java.lang.CharSequence id;
  /** Unique identifier tax code */
  private java.lang.CharSequence taxCode;
  /** ISO identifier for country code */
  private java.lang.CharSequence countryCode;
  /** Tax profile code */
  private java.math.BigDecimal taxProfile;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public Taxation() {}

  /**
   * All-args constructor.
   * @param id Taxation unique identifier profile
   * @param taxCode Unique identifier tax code
   * @param countryCode ISO identifier for country code
   * @param taxProfile Tax profile code
   */
  public Taxation(java.lang.CharSequence id, java.lang.CharSequence taxCode, java.lang.CharSequence countryCode, java.math.BigDecimal taxProfile) {
    this.id = id;
    this.taxCode = taxCode;
    this.countryCode = countryCode;
    this.taxProfile = taxProfile;
  }

  @Override
  public org.apache.avro.specific.SpecificData getSpecificData() { return MODEL$; }

  @Override
  public org.apache.avro.Schema getSchema() { return SCHEMA$; }

  // Used by DatumWriter.  Applications should not call.
  @Override
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return id;
    case 1: return taxCode;
    case 2: return countryCode;
    case 3: return taxProfile;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  // Used by DatumReader.  Applications should not call.
  @Override
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: id = (java.lang.CharSequence)value$; break;
    case 1: taxCode = (java.lang.CharSequence)value$; break;
    case 2: countryCode = (java.lang.CharSequence)value$; break;
    case 3: taxProfile = (java.math.BigDecimal)value$; break;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  /**
   * Gets the value of the 'id' field.
   * @return Taxation unique identifier profile
   */
  public java.lang.CharSequence getId() {
    return id;
  }


  /**
   * Sets the value of the 'id' field.
   * Taxation unique identifier profile
   * @param value the value to set.
   */
  public void setId(java.lang.CharSequence value) {
    this.id = value;
  }

  /**
   * Gets the value of the 'taxCode' field.
   * @return Unique identifier tax code
   */
  public java.lang.CharSequence getTaxCode() {
    return taxCode;
  }


  /**
   * Sets the value of the 'taxCode' field.
   * Unique identifier tax code
   * @param value the value to set.
   */
  public void setTaxCode(java.lang.CharSequence value) {
    this.taxCode = value;
  }

  /**
   * Gets the value of the 'countryCode' field.
   * @return ISO identifier for country code
   */
  public java.lang.CharSequence getCountryCode() {
    return countryCode;
  }


  /**
   * Sets the value of the 'countryCode' field.
   * ISO identifier for country code
   * @param value the value to set.
   */
  public void setCountryCode(java.lang.CharSequence value) {
    this.countryCode = value;
  }

  /**
   * Gets the value of the 'taxProfile' field.
   * @return Tax profile code
   */
  public java.math.BigDecimal getTaxProfile() {
    return taxProfile;
  }


  /**
   * Sets the value of the 'taxProfile' field.
   * Tax profile code
   * @param value the value to set.
   */
  public void setTaxProfile(java.math.BigDecimal value) {
    this.taxProfile = value;
  }

  /**
   * Creates a new Taxation RecordBuilder.
   * @return A new Taxation RecordBuilder
   */
  public static com.marcofabbian.transaction.avroschema.Taxation.Builder newBuilder() {
    return new com.marcofabbian.transaction.avroschema.Taxation.Builder();
  }

  /**
   * Creates a new Taxation RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new Taxation RecordBuilder
   */
  public static com.marcofabbian.transaction.avroschema.Taxation.Builder newBuilder(com.marcofabbian.transaction.avroschema.Taxation.Builder other) {
    if (other == null) {
      return new com.marcofabbian.transaction.avroschema.Taxation.Builder();
    } else {
      return new com.marcofabbian.transaction.avroschema.Taxation.Builder(other);
    }
  }

  /**
   * Creates a new Taxation RecordBuilder by copying an existing Taxation instance.
   * @param other The existing instance to copy.
   * @return A new Taxation RecordBuilder
   */
  public static com.marcofabbian.transaction.avroschema.Taxation.Builder newBuilder(com.marcofabbian.transaction.avroschema.Taxation other) {
    if (other == null) {
      return new com.marcofabbian.transaction.avroschema.Taxation.Builder();
    } else {
      return new com.marcofabbian.transaction.avroschema.Taxation.Builder(other);
    }
  }

  /**
   * RecordBuilder for Taxation instances.
   */
  @org.apache.avro.specific.AvroGenerated
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<Taxation>
    implements org.apache.avro.data.RecordBuilder<Taxation> {

    /** Taxation unique identifier profile */
    private java.lang.CharSequence id;
    /** Unique identifier tax code */
    private java.lang.CharSequence taxCode;
    /** ISO identifier for country code */
    private java.lang.CharSequence countryCode;
    /** Tax profile code */
    private java.math.BigDecimal taxProfile;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$, MODEL$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(com.marcofabbian.transaction.avroschema.Taxation.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = other.fieldSetFlags()[0];
      }
      if (isValidValue(fields()[1], other.taxCode)) {
        this.taxCode = data().deepCopy(fields()[1].schema(), other.taxCode);
        fieldSetFlags()[1] = other.fieldSetFlags()[1];
      }
      if (isValidValue(fields()[2], other.countryCode)) {
        this.countryCode = data().deepCopy(fields()[2].schema(), other.countryCode);
        fieldSetFlags()[2] = other.fieldSetFlags()[2];
      }
      if (isValidValue(fields()[3], other.taxProfile)) {
        this.taxProfile = data().deepCopy(fields()[3].schema(), other.taxProfile);
        fieldSetFlags()[3] = other.fieldSetFlags()[3];
      }
    }

    /**
     * Creates a Builder by copying an existing Taxation instance
     * @param other The existing instance to copy.
     */
    private Builder(com.marcofabbian.transaction.avroschema.Taxation other) {
      super(SCHEMA$, MODEL$);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.taxCode)) {
        this.taxCode = data().deepCopy(fields()[1].schema(), other.taxCode);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.countryCode)) {
        this.countryCode = data().deepCopy(fields()[2].schema(), other.countryCode);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.taxProfile)) {
        this.taxProfile = data().deepCopy(fields()[3].schema(), other.taxProfile);
        fieldSetFlags()[3] = true;
      }
    }

    /**
      * Gets the value of the 'id' field.
      * Taxation unique identifier profile
      * @return The value.
      */
    public java.lang.CharSequence getId() {
      return id;
    }


    /**
      * Sets the value of the 'id' field.
      * Taxation unique identifier profile
      * @param value The value of 'id'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Taxation.Builder setId(java.lang.CharSequence value) {
      validate(fields()[0], value);
      this.id = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'id' field has been set.
      * Taxation unique identifier profile
      * @return True if the 'id' field has been set, false otherwise.
      */
    public boolean hasId() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'id' field.
      * Taxation unique identifier profile
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Taxation.Builder clearId() {
      id = null;
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'taxCode' field.
      * Unique identifier tax code
      * @return The value.
      */
    public java.lang.CharSequence getTaxCode() {
      return taxCode;
    }


    /**
      * Sets the value of the 'taxCode' field.
      * Unique identifier tax code
      * @param value The value of 'taxCode'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Taxation.Builder setTaxCode(java.lang.CharSequence value) {
      validate(fields()[1], value);
      this.taxCode = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'taxCode' field has been set.
      * Unique identifier tax code
      * @return True if the 'taxCode' field has been set, false otherwise.
      */
    public boolean hasTaxCode() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'taxCode' field.
      * Unique identifier tax code
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Taxation.Builder clearTaxCode() {
      taxCode = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'countryCode' field.
      * ISO identifier for country code
      * @return The value.
      */
    public java.lang.CharSequence getCountryCode() {
      return countryCode;
    }


    /**
      * Sets the value of the 'countryCode' field.
      * ISO identifier for country code
      * @param value The value of 'countryCode'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Taxation.Builder setCountryCode(java.lang.CharSequence value) {
      validate(fields()[2], value);
      this.countryCode = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'countryCode' field has been set.
      * ISO identifier for country code
      * @return True if the 'countryCode' field has been set, false otherwise.
      */
    public boolean hasCountryCode() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'countryCode' field.
      * ISO identifier for country code
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Taxation.Builder clearCountryCode() {
      countryCode = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'taxProfile' field.
      * Tax profile code
      * @return The value.
      */
    public java.math.BigDecimal getTaxProfile() {
      return taxProfile;
    }


    /**
      * Sets the value of the 'taxProfile' field.
      * Tax profile code
      * @param value The value of 'taxProfile'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Taxation.Builder setTaxProfile(java.math.BigDecimal value) {
      validate(fields()[3], value);
      this.taxProfile = value;
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'taxProfile' field has been set.
      * Tax profile code
      * @return True if the 'taxProfile' field has been set, false otherwise.
      */
    public boolean hasTaxProfile() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'taxProfile' field.
      * Tax profile code
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Taxation.Builder clearTaxProfile() {
      taxProfile = null;
      fieldSetFlags()[3] = false;
      return this;
    }

    @Override
    @SuppressWarnings("unchecked")
    public Taxation build() {
      try {
        Taxation record = new Taxation();
        record.id = fieldSetFlags()[0] ? this.id : (java.lang.CharSequence) defaultValue(fields()[0]);
        record.taxCode = fieldSetFlags()[1] ? this.taxCode : (java.lang.CharSequence) defaultValue(fields()[1]);
        record.countryCode = fieldSetFlags()[2] ? this.countryCode : (java.lang.CharSequence) defaultValue(fields()[2]);
        record.taxProfile = fieldSetFlags()[3] ? this.taxProfile : (java.math.BigDecimal) defaultValue(fields()[3]);
        return record;
      } catch (org.apache.avro.AvroMissingFieldException e) {
        throw e;
      } catch (java.lang.Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumWriter<Taxation>
    WRITER$ = (org.apache.avro.io.DatumWriter<Taxation>)MODEL$.createDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumReader<Taxation>
    READER$ = (org.apache.avro.io.DatumReader<Taxation>)MODEL$.createDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

  @Override protected boolean hasCustomCoders() { return true; }

  @Override public void customEncode(org.apache.avro.io.Encoder out)
    throws java.io.IOException
  {
    out.writeString(this.id);

    out.writeString(this.taxCode);

    out.writeString(this.countryCode);

    out.writeString(this.taxProfile.toString());

  }

  @Override public void customDecode(org.apache.avro.io.ResolvingDecoder in)
    throws java.io.IOException
  {
    org.apache.avro.Schema.Field[] fieldOrder = in.readFieldOrderIfDiff();
    if (fieldOrder == null) {
      this.id = in.readString(this.id instanceof Utf8 ? (Utf8)this.id : null);

      this.taxCode = in.readString(this.taxCode instanceof Utf8 ? (Utf8)this.taxCode : null);

      this.countryCode = in.readString(this.countryCode instanceof Utf8 ? (Utf8)this.countryCode : null);

      this.taxProfile = new java.math.BigDecimal(in.readString());

    } else {
      for (int i = 0; i < 4; i++) {
        switch (fieldOrder[i].pos()) {
        case 0:
          this.id = in.readString(this.id instanceof Utf8 ? (Utf8)this.id : null);
          break;

        case 1:
          this.taxCode = in.readString(this.taxCode instanceof Utf8 ? (Utf8)this.taxCode : null);
          break;

        case 2:
          this.countryCode = in.readString(this.countryCode instanceof Utf8 ? (Utf8)this.countryCode : null);
          break;

        case 3:
          this.taxProfile = new java.math.BigDecimal(in.readString());
          break;

        default:
          throw new java.io.IOException("Corrupt ResolvingDecoder.");
        }
      }
    }
  }
}










